"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var parseTwoslashAssertion_exports = {};
__export(parseTwoslashAssertion_exports, {
  parseTwoslashAssertion: () => parseTwoslashAssertion
});
module.exports = __toCommonJS(parseTwoslashAssertion_exports);
function parseTwoslashAssertion(comment, commentIndex, commentLine, sourceText, lineStarts) {
  const matchTwoslash = /^( *)\^\?(.*)$/.exec(comment);
  if (!matchTwoslash) {
    return null;
  }
  const whitespace = matchTwoslash[1];
  const rawPayload = matchTwoslash[2];
  if (rawPayload.length && !rawPayload.startsWith(" ")) {
    return {
      line: commentLine - 1,
      type: "InvalidTwoslash"
    };
  }
  let expected = rawPayload.slice(1);
  if (commentLine === 1) {
    return {
      assertionType: "twoslash",
      expected,
      expectedPrefix: "",
      expectedRange: [-1, -1],
      insertSpace: false,
      position: -1
    };
  }
  const caretIndex = commentIndex + whitespace.length + 2;
  const position = caretIndex - (lineStarts[commentLine - 1] - lineStarts[commentLine - 2]);
  const expectedRange = [
    commentIndex + whitespace.length + 5,
    commentLine < lineStarts.length ? lineStarts[commentLine] - 1 : sourceText.length
  ];
  const expectedPrefix = sourceText.slice(
    lineStarts[commentLine - 1],
    commentIndex + 2 + whitespace.length
  ) + "   ";
  for (let nextLine = commentLine; nextLine < lineStarts.length; nextLine++) {
    const thisLineEnd = nextLine + 1 < lineStarts.length ? lineStarts[nextLine + 1] - 1 : sourceText.length;
    const lineText = sourceText.slice(lineStarts[nextLine], thisLineEnd + 1);
    if (lineText.startsWith(expectedPrefix)) {
      if (nextLine === commentLine) {
        expected += "\n";
      }
      expected += lineText.slice(expectedPrefix.length);
      expectedRange[1] = thisLineEnd;
    } else {
      break;
    }
  }
  let insertSpace = false;
  if (expectedRange[0] > expectedRange[1]) {
    expectedRange[0] = expectedRange[1];
    insertSpace = true;
  }
  return {
    assertionType: "twoslash",
    expected,
    expectedPrefix,
    expectedRange,
    insertSpace,
    position
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  parseTwoslashAssertion
});
//# sourceMappingURL=parseTwoslashAssertion.js.map