"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getExpectTypeFailures_exports = {};
__export(getExpectTypeFailures_exports, {
  getExpectTypeFailures: () => getExpectTypeFailures
});
module.exports = __toCommonJS(getExpectTypeFailures_exports);
var import_typescript = __toESM(require("typescript"));
var import_locations = require("../utils/locations.js");
var import_locations2 = require("../utils/locations.js");
var import_typescript2 = require("../utils/typescript.js");
function getExpectTypeFailures(sourceFile, assertions, program) {
  const checker = program.getTypeChecker();
  const languageService = import_typescript.default.createLanguageService(
    (0, import_typescript2.getLanguageServiceHost)(program)
  );
  const { twoSlashAssertions, typeAssertions } = assertions;
  const unmetExpectations = [];
  import_typescript.default.forEachChild(sourceFile, function iterate(node) {
    const line = (0, import_locations2.lineOfPosition)(node.getStart(sourceFile), sourceFile);
    const assertion = typeAssertions.get(line);
    if (assertion !== void 0) {
      const { expected } = assertion;
      let nodeToCheck = node;
      if (node.kind === import_typescript.default.SyntaxKind.ExpressionStatement) {
        node = node.expression;
      }
      nodeToCheck = (0, import_typescript2.getNodeForExpectType)(node);
      const type = checker.getTypeAtLocation(nodeToCheck);
      const actual = checker.typeToString(
        type,
        /*enclosingDeclaration*/
        void 0,
        import_typescript.default.TypeFormatFlags.NoTruncation
      );
      if (!expected || actual !== expected && !(0, import_typescript2.matchReadonlyArray)(actual, expected)) {
        unmetExpectations.push({ actual, assertion, node });
      }
      typeAssertions.delete(line);
    }
    import_typescript.default.forEachChild(node, iterate);
  });
  const twoSlashFailureLines = [];
  if (twoSlashAssertions.length) {
    for (const assertion of twoSlashAssertions) {
      const { expected, position } = assertion;
      if (position === -1) {
        twoSlashFailureLines.push(0);
        continue;
      }
      const node = (0, import_locations.getNodeAtPosition)(sourceFile, position);
      if (!node) {
        twoSlashFailureLines.push(
          sourceFile.getLineAndCharacterOfPosition(position).line
        );
        continue;
      }
      const qi = languageService.getQuickInfoAtPosition(
        sourceFile.fileName,
        node.getStart()
      );
      if (!qi?.displayParts) {
        twoSlashFailureLines.push(
          sourceFile.getLineAndCharacterOfPosition(position).line
        );
        continue;
      }
      const actual = qi.displayParts.map((dp) => dp.text).join("");
      if (!(0, import_typescript2.matchModuloWhitespace)(actual, expected)) {
        unmetExpectations.push({
          actual,
          assertion,
          node
        });
      }
    }
  }
  return {
    unmetExpectations,
    unusedAssertions: [...twoSlashFailureLines, ...typeAssertions.keys()]
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getExpectTypeFailures
});
//# sourceMappingURL=getExpectTypeFailures.js.map