import ts__default from 'typescript';
import { Assertion } from '../assertions/types.mjs';

interface UnmetExpectation {
    actual: string;
    assertion: Assertion;
    node: ts__default.Node;
}
interface ExpectTypeFailures {
    /**
     * Lines with an $ExpectType, but a different type was there.
     */
    readonly unmetExpectations: readonly UnmetExpectation[];
    /**
     * Lines with an $ExpectType, but no node could be found.
     */
    readonly unusedAssertions: Iterable<number>;
}

export type { ExpectTypeFailures, UnmetExpectation };
