import { ESLintUtils } from '@typescript-eslint/utils';

declare const messages: {
    ExpectedErrorNotFound: string;
    FileIsNotIncludedInTSConfig: string;
    Multiple$ExpectTypeAssertions: string;
    OrphanAssertion: string;
    SyntaxError: string;
    TypeSnapshotDoNotMatch: string;
    TypeSnapshotNotFound: string;
    TypesDoNotMatch: string;
};
type MessageIds = keyof typeof messages;
interface Options {
    readonly disableExpectTypeSnapshotFix: boolean;
}
declare const expect: ESLintUtils.RuleModule<"ExpectedErrorNotFound" | "FileIsNotIncludedInTSConfig" | "Multiple$ExpectTypeAssertions" | "OrphanAssertion" | "SyntaxError" | "TypeSnapshotDoNotMatch" | "TypeSnapshotNotFound" | "TypesDoNotMatch", [Options], ESLintUtils.RuleListener>;

export { type MessageIds, type Options, expect };
