"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var locations_exports = {};
__export(locations_exports, {
  getNodeAtPosition: () => getNodeAtPosition,
  lineOfPosition: () => lineOfPosition,
  locForTSNode: () => locForTSNode
});
module.exports = __toCommonJS(locations_exports);
var ts = __toESM(require("typescript"));
const locForTSNode = (sourceFile, node) => {
  const start = sourceFile.getLineAndCharacterOfPosition(node.getStart());
  const end = sourceFile.getLineAndCharacterOfPosition(node.getEnd());
  return {
    end: {
      column: end.character,
      line: end.line + 1
    },
    start: {
      column: start.character,
      line: start.line + 1
    }
  };
};
function lineOfPosition(pos, sourceFile) {
  return sourceFile.getLineAndCharacterOfPosition(pos).line;
}
function getNodeAtPosition(sourceFile, position) {
  let candidate = void 0;
  ts.forEachChild(sourceFile, function iterate(node) {
    const start = node.getStart();
    const end = node.getEnd();
    if (position >= start && position <= end) {
      candidate = node;
      ts.forEachChild(node, iterate);
    }
  });
  return candidate;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getNodeAtPosition,
  lineOfPosition,
  locForTSNode
});
//# sourceMappingURL=locations.js.map