import * as ts from "typescript";
const locForTSNode = (sourceFile, node) => {
  const start = sourceFile.getLineAndCharacterOfPosition(node.getStart());
  const end = sourceFile.getLineAndCharacterOfPosition(node.getEnd());
  return {
    end: {
      column: end.character,
      line: end.line + 1
    },
    start: {
      column: start.character,
      line: start.line + 1
    }
  };
};
function lineOfPosition(pos, sourceFile) {
  return sourceFile.getLineAndCharacterOfPosition(pos).line;
}
function getNodeAtPosition(sourceFile, position) {
  let candidate = void 0;
  ts.forEachChild(sourceFile, function iterate(node) {
    const start = node.getStart();
    const end = node.getEnd();
    if (position >= start && position <= end) {
      candidate = node;
      ts.forEachChild(node, iterate);
    }
  });
  return candidate;
}
export {
  getNodeAtPosition,
  lineOfPosition,
  locForTSNode
};
//# sourceMappingURL=locations.mjs.map