"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var snapshot_exports = {};
__export(snapshot_exports, {
  getTypeSnapshot: () => getTypeSnapshot,
  updateTypeSnapshot: () => updateTypeSnapshot
});
module.exports = __toCommonJS(snapshot_exports);
var fse = __toESM(require("fs-extra"));
var import_path = require("path");
const { ensureFileSync, readJsonSync, writeJsonSync } = fse;
const getTypeSnapshot = (filename, snapshotName) => {
  const snapshotPath = getSnapshotPath(filename);
  const json = readJsonSync(snapshotPath, { throws: false });
  if (!json) {
    return;
  }
  return json[snapshotName];
};
const updateTypeSnapshot = (filename, snapshotName, actualType) => {
  const snapshotPath = getSnapshotPath(filename);
  ensureFileSync(snapshotPath);
  const json = readJsonSync(snapshotPath, { throws: false }) ?? {};
  json[snapshotName] = actualType;
  writeJsonSync(snapshotPath, json, { spaces: 2 });
};
function getSnapshotPath(filename) {
  const directory = (0, import_path.dirname)(filename);
  return (0, import_path.resolve)(
    directory,
    "__type-snapshots__",
    `${(0, import_path.basename)(filename)}.snap.json`
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getTypeSnapshot,
  updateTypeSnapshot
});
//# sourceMappingURL=snapshot.js.map