"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var typescript_exports = {};
__export(typescript_exports, {
  getLanguageServiceHost: () => getLanguageServiceHost,
  getNodeForExpectType: () => getNodeForExpectType,
  matchModuloWhitespace: () => matchModuloWhitespace,
  matchReadonlyArray: () => matchReadonlyArray
});
module.exports = __toCommonJS(typescript_exports);
var ts = __toESM(require("typescript"));
function getLanguageServiceHost(program) {
  return {
    getCompilationSettings: () => program.getCompilerOptions(),
    getCurrentDirectory: () => program.getCurrentDirectory(),
    getDefaultLibFileName: (options) => ts.getDefaultLibFilePath(options),
    getScriptFileNames: () => program.getSourceFiles().map((sourceFile) => sourceFile.fileName),
    getScriptSnapshot: (name) => ts.ScriptSnapshot.fromString(program.getSourceFile(name)?.text ?? ""),
    getScriptVersion: () => "1",
    // NB: We can't check `program` for files, it won't contain valid files like package.json
    /* eslint-disable @typescript-eslint/unbound-method */
    directoryExists: ts.sys.directoryExists,
    fileExists: ts.sys.fileExists,
    getDirectories: ts.sys.getDirectories,
    readDirectory: ts.sys.readDirectory,
    readFile: ts.sys.readFile
    /* eslint-enable @typescript-eslint/unbound-method */
  };
}
function getNodeForExpectType(node) {
  if (ts.isVariableStatement(node)) {
    const {
      declarationList: { declarations }
    } = node;
    if (declarations.length === 1) {
      const { initializer } = declarations[0];
      if (initializer) {
        return initializer;
      }
    }
  }
  return node;
}
function matchReadonlyArray(actual, expected) {
  if (!(/\breadonly\b/.test(actual) && /\bReadonlyArray\b/.test(expected))) {
    return false;
  }
  const readonlyArrayRegExp = /\bReadonlyArray</y;
  const readonlyModifierRegExp = /\breadonly /y;
  let expectedPos = 0;
  let actualPos = 0;
  let depth = 0;
  while (expectedPos < expected.length && actualPos < actual.length) {
    const expectedChar = expected.charAt(expectedPos);
    const actualChar = actual.charAt(actualPos);
    if (expectedChar === actualChar) {
      expectedPos++;
      actualPos++;
      continue;
    }
    if (depth > 0 && expectedChar === ">" && actualChar === "[" && actualPos < actual.length - 1 && actual.charAt(actualPos + 1) === "]") {
      depth--;
      expectedPos++;
      actualPos += 2;
      continue;
    }
    readonlyArrayRegExp.lastIndex = expectedPos;
    readonlyModifierRegExp.lastIndex = actualPos;
    if (readonlyArrayRegExp.test(expected) && readonlyModifierRegExp.test(actual)) {
      depth++;
      expectedPos += 14;
      actualPos += 9;
      continue;
    }
    return false;
  }
  return true;
}
function matchModuloWhitespace(actual, expected) {
  const normActual = actual.replace(/[\n\r ]+/g, " ").trim();
  const normExpected = expected.replace(/[\n\r ]+/g, " ").trim();
  return normActual === normExpected;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getLanguageServiceHost,
  getNodeForExpectType,
  matchModuloWhitespace,
  matchReadonlyArray
});
//# sourceMappingURL=typescript.js.map